TPROF(8)

NAME
tprof - record tprof profiling samples

SYNOPSIS
tprof [-c] [-o file] command ...

DESCRIPTION
The tprof is a sampling based profiler.

tprof utility makes the kernel driver start profiling, executes the specified command, keeps recording samples from the kernel driver until the command finishes, and reports statistics to the standard error.

The tprof pseudo driver and a suitable backend should be loaded beforehand.

The tprof utility accepts the following options.

-o file
    Write the collected samples to the file named file. The default is “tprof.out”.

-c  Write the collected samples to the standard output. Note that the output is a binary stream.

EXAMPLES
The following command profiles the system during 1 second and shows the top-10 kernel functions which likely consumed CPU cycles.

    	tprof -c sleep 1 2>/dev/null | tpfmt -skCLP | head -10

DIAGNOSTICS
The tprof utility reports the following statistics about the activities of the tprof pseudo driver.

sample
    The number of samples collected and prepared for userland consumption.

overflow
    The number of samples dropped because the per-CPU buffer was full.

buf The number of buffers successfully prepared for userland consumption.

emptybuf
    The number of buffers which have been dropped because they were empty.

dropbuf
    The number of buffers dropped because the number of buffers kept in the kernel exceeds the limit.

dropbuf_samples
    The number of samples dropped because the buffers containing the samples were dropped.

SEE ALSO
tpfmt(1), tprof(4)

AUTHORS
The tprof utility is written by YAMAMOTO Takashi.

CAVEATS
The contents and representation of recorded samples are undocumented and will likely be changed for future releases of NetBSD in an incompatible way.